import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Klasse, mit der ein Button erstellt werden kann, der eine bestimmte Höhe und Breite hat und mit einem Text in beliebiger Größe beschrieben ist. 
 * Anhand einer ButtonID wird eine in dieser Klasse festgelegte Aktion ausgeführt.
 * 
 * @author (Nico Schmidt) 
 * @version (20.04.17)
 */
public class Button extends Actor
{
    /**
     * Act - do whatever the Button wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */

    int buttonID;       //ID der auszuführenden Aktion
    String text;        //Text auf dem Button
    int textgröße;      //Größe des Textes
    int breite;         //Breite des Buttons
    int höhe;           //Höhe des Buttons

    Button(int eButtonID, String eText, int eTextgröße, int eBreite, int eHöhe) //Im Konstruktor werden die verschiedenen Parameter für die Erstellung des Buttons festgelegt
    {
        buttonID = eButtonID;
        text = eText;
        textgröße = eTextgröße;
        breite = eBreite;
        höhe= eHöhe;
    }

    public void addedToWorld(World world)                                       //Bild des Buttons wird erstellt, wenn der Button in die Welt eingefügt wird.
    {
        GreenfootImage button = new GreenfootImage(breite, höhe);                   //Größe festgelegt
        button.setColor(Color.LIGHT_GRAY);                                          //Farbe auf Grau festgelegt
        button.fill();                                                              //Button mit Grau gefüllt
        GreenfootImage Text = new GreenfootImage(text,textgröße, Color.BLACK, new Color (0,0,0,0));//TextImage wird erstellt
        button.drawImage(Text,2,1);                                                 //Text wird auf den grauen Hintergrund eingefügt
        setImage(button);                                                           //erstelltes Image wird angewendet
    }

    public void act()
    {
        if (Greenfoot.mouseClicked(this)||getIntersectingObjects(Player.class).size()>0)               //WENN auf den Button geklickt wird
        {
            switch(buttonID)                                //SWITCH Statement zur Abfrage der ButtonID und ausführen der entsprechenden Aktion
            {
                case 0: Greenfoot.setWorld(new Level0());   break;
                case 1: Greenfoot.setWorld(new Level1());   break;
                case 2: Greenfoot.setWorld(new Level2());   break;
                case 3: Greenfoot.setWorld(new Level3());   break;
                case 4: Greenfoot.setWorld(new Level4());   break;
                case 5: Greenfoot.setWorld(new Level5());   break;
                case 6: Greenfoot.setWorld(new Level6());   break;
                case 7: Greenfoot.setWorld(new Level7());   break;
                case 8: Greenfoot.setWorld(new Level8());   break;
                case 9: Greenfoot.setWorld(new Level9());   break;
                case 10: Greenfoot.setWorld(new Level10()); break;
                case 11: Greenfoot.setWorld(new Level11());   break;
                case 12: Greenfoot.setWorld(new Level12());   break;
                case 13: Greenfoot.setWorld(new Level13());   break;
                //case 14: Greenfoot.setWorld(new Level14());   break;
                //case 15: Greenfoot.setWorld(new Level15());   break;
                //case 16: Greenfoot.setWorld(new Level16());   break;
                //case 17: Greenfoot.setWorld(new Level17());   break;
                //case 18: Greenfoot.setWorld(new Level18());   break;
                //case 19: Greenfoot.setWorld(new Level19());   break;
                //case 20: Greenfoot.setWorld(new Level20());   break;
                //case 21: Greenfoot.setWorld(new Level21()); break;
                case 33: Greenfoot.setWorld(new Level33());   break;
                default: Greenfoot.setWorld(new Levelauswahl()); break;
            }
        }
    }
}
