import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Gegner Klasse, die alle Methoden für Bewegungen, Festlegung von Geschwindigkeit, Angriffen und anderen Fähigkeiten von Gegnern enthält
 * 
 * @author (Nico Schmidt) 
 * @version (11.05.17)
 */
public class Enemy extends Actor
{
    int speed;                                  //Bewegungsgeschwindigkeit
    String [] img_;                             //Array für die Speicherung der Dateinamen der Bilder
    int bildIndex = 0;                          //Index zur Festlegung des aktuellen Bilds 
    boolean grow = true;                        //Boolean zur Festlegung der Phase der Ausdehnung bzw des Zusammenziehens
    List<Player> Players;                       //Liste für lokalisierte Spieler
    Player player;                              //Spieler, der verfolgt wird
    int oldX;                                   //Variable, um das eindringen in Wände zu verhindern
    int oldY;                                   //Variable, um das eindringen in Wände zu verhindern
    int spin;                                   //Variable zur Festlegung der Drehgeschwindigkeit
    Bullet bullet;                              //Munition
    int startX;                                 //Integer für die anfängliche X-Position
    int startY;                                 //Integer für die anfängliche Y-Position

    public void setSpeed(int x)                  //Festlegung der Geschwindigkeit für die Bewegung
    {
        speed = x; 
    }

    public void setSpin(int y)                  //Festlegung der Drehgeschwindigkeit für die Rotation
    {
        spin = y; 
    }
    
    public int getSpin ()                       //Methode, die den aktuellen Spin zurück gibt
    { 
        return spin;
    }
    
    public void setImages(String dot)           //Festlegung des Dot für das Abrufen der png Dateien für das Ausdehnen und Zusammenziehen des jeweiligen Dots
    {
        img_ = new String [40];                     //Festlegung der Bildanzahl auf 40
        for(int i = 0; i < img_.length; i++)        //Schleife für die Speicherung der Bildnamen im Array img_
        {
            img_[i]= dot+Integer.toString(i+10)+".png";     //Zusammensetzung des Dateinamen
        }
    }

    public void laden (int bulletSpeed)         //Munition für Gegnertypen, die schießen wird erstellt und die Geschwindigkeit festgelegt
    {
        bullet = new Bullet();                      //neue Kugel wird erstellt
        getWorld().addObject(bullet,getX(),getY()); //neue Kugel wird an der Position des Genertyps eingefügt
        bullet.setSpeed(bulletSpeed);               //Geschwindigkeit der Kugel wird festgelegt
        bullet.setRotation(getRotation());          //Rotation wird festgelegt
    }

    public void StartPos()                      //Methode zur Festlegung der Startposition
    {
        startX = getX();
        startY = getY(); 
    }

    public void nachladen ()                    //setzt Position des Projektils zurück auf Gegner, wenn es eine Wand oder den Rand berührt
    {
        if (bullet.isTouching(Wall.class)||bullet.isAtEdge()||bullet.isTouching(TargetArea.class))
        {
            bullet.setLocation(getX(),getY());      //Position zurücksetzen
            bullet.setRotation(getRotation());      //Rotation festlegen
        }
    }

    public void steuerung()           //Steuerung für einfache Bewegung nach vorn
    {
        if(isTouching(Wall.class)||isAtEdge()||isTouching(Enemy.class)||isTouching(TargetArea.class))      //wenn Wand oder Rand berührt
        { 
            speed = -speed;                             //Bewegungsrichtung umkehren
        }
        move(speed);          //Objekt in X-Richtung verschieben
        if (getIntersectingObjects( Wall.class).size()>0)// wenn innerhalb einer Wand
        { 
            setLocation(oldX, oldY);                    //Position wird auf die Daten vor der letzten Bewegung zurückgesetzt
        }
        else
        {
            oldX = getX();                              //sonst wird die Position vor der Bewegung festgelegt
            oldY = getY();
            move (speed);                               //und das Objekt wird mit angegebener Geschwindigkeit bewegt
        }
    }
    
    public void steuerungHorizontal()           //Steuerung für horizontale Bewegung zwischen zwei Wänden bzw. Rändern oder anderneGegnern
    {
        if(isTouching(Wall.class)||isAtEdge()||isTouching(Enemy.class)||isTouching(TargetArea.class))      //wenn Wand oder Rand berührt
        { 
            speed = -speed;                             //Bewegungsrichtung umkehren
        }
        setLocation(getX()+speed, getY());          //Objekt in X-Richtung verschieben
    }

    public void steuerungSenkrecht ()           //Steuerung für senkrechte Bewegung zwischen zwei Wänden bzw. Rändern oder anderen Gegnern
    {
        if(isTouching(Wall.class)||isAtEdge()||isTouching(Enemy.class)||isTouching(TargetArea.class))      //wenn Wand oder Rand berührt
        { 
            speed = -speed;                             //Bewegungsrichtung umkehren
        }
        setLocation(getX(), getY()+speed);          //Objekt in Y-Richtung verschieben
    }

    public void SteuerungVorwärts(int a)             //Steuerung für Bewegung in aktuelle Richtung
    {
        if (getObjectsInRange(9 , Wall.class).size()>0||getObjectsAtOffset(a, 0,Wall.class).size()>0||getObjectsAtOffset(-a, 0,Wall.class).size()>0||getObjectsAtOffset(0,a,Wall.class).size()>0||getObjectsAtOffset(0, -a,Wall.class).size()>0)
        { 
            setLocation(oldX, oldY);                    //Position wird auf die Daten vor der letzten Bewegung zurückgesetzt, falls das Objekt einer Wand zu nah kommt
        }
        else
        {
            oldX = getX();                              
            oldY = getY();
            move (speed);                               //Objekt wird mit angegebener Geschwindigkeit bewegt, falls es sich nicht zu nah an der Wand befindet
        }
    }

    public void spreading ()
    {
        if(bildIndex < 39 && grow == true)      //wenn BildIndex kleiner als 39 und Objekt wachsend
        {
            setImage(img_[bildIndex]);              //Bild aktualisieren
            bildIndex++;                            //BildIndex erhöhen
        }
        else if(bildIndex >= 39 && grow == true)//wenn BildIndex gleich 39 und Objekt wachsend
        {
            setImage(img_[bildIndex]);              //Bild aktualisieren
            bildIndex--;                            //BildIndex senken
            grow = false;                           //Zustand zu schrumpfend setzen
        }
        else if(bildIndex > 0 && grow == false) //wenn BildIndex größer als 0 und Objekt schrumpfend
        {
            setImage(img_[bildIndex]);              //Bild aktualisieren
            bildIndex--;                            //BildIndex senken
        }
        else if(bildIndex <= 0 && grow == false)//wenn BildIndex gleich 0 und Objekt schrumpfend
        {
            setImage(img_[bildIndex]);              //Bild aktualisieren
            bildIndex++;                            //BildIndex erhöhen
            grow = true;                            //Zustand zu wachsend setzen
        }
    }

    public void DreheZuSpieler()        //Gegner wird in Richtung des lokalisierten Spielers gedreht
    {
        Players = getObjectsInRange(1000, Player.class);       //Spieler wird in Liste gespeichert
        player = Players.get(0);                                //Spieler wird aus Liste entnommen
        turnTowards(player.getX(),player.getY());               //Gegner in Richtung des Spielers drehen
    }

    public void Drehen ()               //Methode zum gleichmäßigen Drehen von Gegnern
    {
        turn (spin);
    }

    public void ResetBeiKill()          //Methode zum Zurücksetzen der Position des Enemys (wird vom Player aus abgerufen)
    {
            setLocation(startX, startY);
    }
}

