import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Spieler, der mit den Pfeiltasten gesteuert werden kann.
 * 
 * @author (Robin Rocher & Nico Schmidt) 
 * @version (11.05.17)
 */
public class Player extends Actor
{
    int step = 3;                       //groesse der schritte des Players in Pixel
    int startX = 30;                    //Anfangsposition des Players
    int startY = 30;                    //Anfangsposition des Players
    GreenfootSound Impact;              //Geräusch für den Aufprall
    Follower follower;                  //Actor zur Speicherung eines Objektes vom Typ Follower
    List<Follower> followers;           //Liste zur Speicherung mehrerer Objekte vom Typ Follower
    RandomWalker randomWalker;          //Actor zur Speicherung eines Objektes vom Typ RandomWalker
    List<RandomWalker> randomWalkers;   //Liste zur Speicherung mehrerer Objekte vom Typ RandomWalker
    
    
    Player ()
    {
        Impact = new GreenfootSound("Impact.wav");  //Aufprall Geräusch wird festgelegt

        Musik.playMusic();                          //statische Methode aus der Klasse Musik wird abgerufen
    }

    public void addedToWorld(World world) 
    {
        startPosition(); //auf Anfangsposition setzen, geschieht zu Beginn jedes Levels
    }

    /**
     * Act - do whatever the RedSquare wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        int xOld = getX();  //momentane x-Position speichern
        int yOld = getY();  //momentane y-Position speichern
        if (Greenfoot.isKeyDown("left") || Greenfoot.isKeyDown("a")){
            setLocation(getX()-step,getY()); //einen schritt nach links bewegen
        }
        if (Greenfoot.isKeyDown("down") || Greenfoot.isKeyDown("s")){
            setLocation(getX(),getY()+step);    //einen schritt nach unten bewegen
        }
        if (Greenfoot.isKeyDown("right") || Greenfoot.isKeyDown("d")){
            setLocation(getX()+step,getY()); //einen schritt nach links bewegen
        }
        if (Greenfoot.isKeyDown("up") || Greenfoot.isKeyDown("w")){
            setLocation(getX(),getY()-step);    //einen schritt nach unten bewegen
        }
        if (Greenfoot.isKeyDown("escape")){ 
            Greenfoot.setWorld(new Start());    //ins Menü zurückkehren
        }
        if (getIntersectingObjects(WindL.class).size()>0)
        {
            setLocation(getX()-1,getY()); //einen schritt nach links bewegen
        }
        if (getIntersectingObjects(WindR.class).size()>0)
        {
            setLocation(getX()+1,getY());
        }
        if (getIntersectingObjects(WindO.class).size()>0)
        {
            setLocation(getX(),getY()-1);
        }
        if (getIntersectingObjects(WindU.class).size()>0)
        {
            setLocation(getX(),getY()+1); 
        }
        if(getIntersectingObjects(Wall.class).size()>0){ //wenn in Wand bewegt

            if(!Impact.isPlaying())             //wenn Impact nicht spielt
            {
                Impact.play();                      //spiele Impact
            }
            setLocation(xOld, yOld);    //auf alte Position setzen

        }
        if(getIntersectingObjects(Enemy.class).size()>0){ //wenn auf Gegner getroffen
            if(getIntersectingObjects(Follower.class).size()>0)     //wenn ein Follower den Spieler berührt
            {
                followers = getIntersectingObjects(Follower.class);     //Follower wird in Liste gespeichert
                follower = followers.get(0);                            //Follower aus Liste wird in Actor übergeben
                follower.ResetBeiKill();                                //follower wird zurück auf die Startposition zurückgesetzt
                followers.clear();                                      //Liste wird geleert
            }
            else if(getIntersectingObjects(RandomWalker.class).size()>0)        //selbe Prozedur, falls ein RandomWalker den Spieler berührt
            {
                randomWalkers = getIntersectingObjects(RandomWalker.class);
                randomWalker = randomWalkers.get(0);
                randomWalker.ResetBeiKill();
                randomWalkers.clear();
            }
            startPosition();    //zurueck zur Anfangsposition
        }
        if(getIntersectingObjects(TargetArea.class).size()>0){  //wenn targetArea erreicht   
            nextLevel();    //ins naechste Level
        }
    }  

    /**
     * Method startPosition
     * setzt den Player auf die StartPosition
     */
    public void startPosition()
    {
        setLocation(startX,startY);
    }

    /**
     * Method nextLevel
     * erschafft das naechste Level - in Abhaengigkeit vom aktuellen Level
     */
    public void nextLevel()
    {   
        if (getWorld() instanceof Start) {  //wenn die aktuelle Welt ein Level1 ist
            Greenfoot.setWorld(new Levelauswahl()); //mache sie zu einer Level2-Welt
        }
        else if (getWorld() instanceof Levelauswahl) {  //wenn die aktuelle Welt ein Level1 ist
            Greenfoot.setWorld(new Level0()); //mache sie zu einer Level2-Welt
        }
        else if (getWorld() instanceof Level0) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level1());
        }
        else if (getWorld() instanceof Level1) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level2());
        }
        else if (getWorld() instanceof Level2) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level3());
        }
        else if (getWorld() instanceof Level3) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level4());
        }
        else if (getWorld() instanceof Level4) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level5());
        }
        else if (getWorld() instanceof Level5) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level6());
        }
        else if (getWorld() instanceof Level6) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level7());
        }
        else if (getWorld() instanceof Level7) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level8());
        }
        else if (getWorld() instanceof Level8) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level9());
        }
        else if (getWorld() instanceof Level9) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level10());
        }
        else if (getWorld() instanceof Level10) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level11());
        }
        else if (getWorld() instanceof Level11) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level12());
        }
        else if (getWorld() instanceof Level12) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level13());
        }
        else if (getWorld() instanceof Level13) {
            getWorld().addObject(new LevelGeschafft() ,300,200);
            Greenfoot.setWorld(new Level14());
        }
    }
}